<?php
//add setting page to menu



if (!class_exists('WP_List_Table')) {
	require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
}


    
	if (isset($_POST['wra_assign-product-submit']) && isset($_POST['wra_product'])) {
	    
	    
		global $wpdb;
		$table = $wpdb->base_prefix . 'wra_products_map';
		$wra_error=false;
		// بررسی شناسه کالای تکراری
		foreach ($_POST['wra_product'] as $key1 => $product1) {
		    foreach ($_POST['wra_product'] as $key2 => $product2) {
		    //$query = "select productCode from {$table} where productId != {$key} and productCode={$product}";
		    //$product_item = $wpdb->query($query);
		    
		    if($key1 != $key2 && $product1 == $product2 && $product1)
		    {
		        $wra_error = 'شناسه کالای '.$product1.' تکراری است.';
		        
		        break;
		    }
		    }
		}
	
		if(!$wra_error)
		{
            $sql = "UPDATE {$table} SET productCode =''";
        	$wpdb->query($sql);
        	
    		foreach ($_POST['wra_product'] as $key => $product) {
       			if ($wpdb->query("SELECT * FROM {$table} WHERE productId=" . $key)) {
     				$sql = "UPDATE {$table} set productCode={$product} WHERE productId=" . $key;
     			} else {
    				$sql = "INSERT INTO {$table} (`productId` , `productCode`, `apiProductId`, `ProductCnuId`) VALUES ({$key},{$product},0,0)";
    			}
    
    			$wpdb->query($sql);
    		}
    		
    		$sql = "DELETE FROM {$table} WHERE productCode =''";
        	$wpdb->query($sql);
    		
    		wra_notice('تغییرات با موفقیت ذخیره شد.', 'success');
		}
		else
		{
		        wra_notice($wra_error, 'error');
		}
	}



function wra_rest_api_products_page_content()
{


	?>
	<div class="wrap">
		<h1>انتساب محصولات</h1>
		<form method="post">
			<?php
			$wp_list_table = new Wra_Product_List_Table();
			$wp_list_table->prepare_items();
			$wp_list_table->display();
			?>
		</form>
	</div>
	<?php
}


class Wra_Product_List_Table extends WP_List_Table
{
	public function __construct()
	{
		parent::__construct(
			array(
				'singular' => 'test',
				'plural' => 'tests',
				'ajax' => false
			)
		);
	}

	function extra_tablenav($which)
	{
		if ($which == "top") {
			echo "";
		}
		if ($which == "bottom") {
			echo "<button type='submit' name='wra_assign-product-submit' class='button button-primary'>ذخیره تغییرات</button>";
		}
	}

	function get_columns()
	{
		$columns = array(
			'productTitle' => 'نام کالا در سایت',
			'siteProductId' => 'شناسه کالا در نرم افزار',
		);
		return $columns;
	}

	function get_sortable_columns()
	{
		return $sortable = array(
			'id' => array('id', false),
			'productTitle' => array('productTitle', false),
		);
	}


	function column_default($item, $column_name)
	{

		$args = array(
			'taxonomy' => "product_cat",
			'hide_empty' => 0,
		);
		$product_categories = get_terms($args);

		global $wpdb;
		$query = "SELECT * FROM {$wpdb->base_prefix}wra_products_map";
		$product_list = $wpdb->get_results($query);

		$select_data = '';

		// if ($column_name == 'siteGroupId' && $product_categories)
		// {
		// 	foreach ($product_categories as $category) {


		// 			if ($category->term_id == $item['siteGroupId'])
		// 				$select_data .= "<option value='" . $category->term_id . "' selected>" . $category->name . "</option>";
		// 			elseif(!$item[$column_name] && wra_fix_letter($category->name)==wra_fix_letter($item['title']))
		// 				$select_data .= "<option value='" . $category->term_id . "' selected>" . $category->name . "</option>";    				
		// 			else
		// 				$select_data .= "<option value='" . $category->term_id . "'>" . $category->name . "</option>";


		// 	}
		// }



		switch ($column_name) {
			case 'id':
			case 'productTitle':
				return $item[$column_name];
			case 'siteProductId':
				return "<input name='wra_product[" . $item['siteProductId'] . "]' class='form-control' value='" . $item['productCode'] . "'>";
			default:
				return print_r($item, true);
		}
	}

	function prepare_items()
	{
		global $wpdb;
		$query = "SELECT pm.productCode,pm.id as id, p.post_title as productTitle, p.ID as siteProductId FROM {$wpdb->base_prefix}posts as p left join {$wpdb->base_prefix}wra_products_map as pm on pm.productId=p.ID where p.post_type='product' and p.post_status = 'publish'";
		
		//$query = "SELECT id,productId as siteProductId,productCode FROM {$wpdb->base_prefix}wra_products_map";
		$orderby = !empty($_GET["orderby"]) ? $_GET["orderby"] : 'ASC';
		$order = !empty($_GET["order"]) ? $_GET["order"] : '';
		if (!empty($orderby) & !empty($order)) {
			$query .= ' ORDER BY p.post_title ' . $order;
		}
		$totalitems = $wpdb->query($query);
		$perpage = 20;
		$paged = !empty($_GET["paged"]) ? intval($_GET["paged"]) : '';
		if (empty($paged) || !is_numeric($paged) || $paged <= 0) {
			$paged = 1;
		}
		$totalpages = ceil($totalitems / $perpage);
		if (!empty($paged) && !empty($perpage)) {
			$offset = ($paged - 1) * $perpage;
			$query .= ' LIMIT ' . (int) $offset . ',' . (int) $perpage;
		}
		$this->set_pagination_args(
			array(
				"total_items" => $totalitems,
				"total_pages" => $totalpages,
				"per_page" => $perpage,
			)
		);
		$columns = $this->get_columns();
		$hidden = array();
		$sortable = $this->get_sortable_columns();
		$this->_column_headers = array($columns, $hidden, $sortable);
		$produts = $wpdb->get_results($query);

		$items = $produts;
		if ($items)
			foreach ($items as &$item)
				$item = (array) $item;
		$this->items = (array) $items;
	}
}