<?php
class Wra_Product_class
{
	public function __construct()
	{

	}
	public function get_product($id)
	{
		$product = wc_get_product($id);
		return $product;
	}

	public function add_product($data)
	{

		if(get_option('wra_update_description')=='on')
		{
			$post_id = wp_insert_post(
				array(
					'post_title' => $data['name'],
					'post_content' => $data['description'],
					'post_status' => $data['status'],
					'post_type' => "product",
				)
			);
		}
		else
		{
			$post_id = wp_insert_post(
				array(
					'post_title' => $data['name'],
					'post_status' => $data['status'],
					'post_type' => "product",
				)
			);
		}

		$product = wc_get_product($post_id);
		if($product)
			$this->update_fields($product, $data);
	}


	public function update_product($id, $data = null)
	{

		if(get_option('wra_update_description')=='on')
		{
			wp_update_post(
				array(
					'ID' => $id,
					// 'post_title' => $data['name'],
					'post_content' => $data['description'],
					'post_status' => $data['status'],
				)
			);
		}
		else
		{
			wp_update_post(
				array(
					'ID' => $id,
					// 'post_title' => $data['name'],
					'post_status' => $data['status'],
				)
			);
		}

		$product = wc_get_product($id);
	
		if($product)
			$this->update_fields($product, $data);
		
	}





	public function update_product_stock($product_id, $quantity)
	{
		global $woocommerce;
		$woocmmerce_instance = new WC_Product($product_id);
		$new_quantity = wc_update_product_stock($woocmmerce_instance, $quantity);

	}

	public function update_fields($product, $data = null)
	{
		
		$unit = 1;
		$wra_priceInWC = get_option('wra_priceInWC');
		$wra_priceInApp = get_option('wra_priceInApp');
		if ($wra_priceInWC == 'ریال')
			$unit *= 10;
		if ($wra_priceInApp == 'ریال')
			$unit /= 10;

		global $wpdb;
		if ($data['productId']) {
			$query = "SELECT * FROM {$wpdb->base_prefix}wra_products_map where productCode='".$data['sku']."'";
			$result = $wpdb->get_results($query);
			if (!$result) {
				$query = "INSERT INTO `{$wpdb->base_prefix}wra_products_map` (`productId`, `apiProductId`, `ProductCnuId`, `productCode`) VALUES ('{$product->id}', '{$data['productId']}', '{$data['productUnitID']}', '{$data['sku']}');"; 
				$wpdb->query($query);
			}
			else
			{
				$query = "UPDATE `{$wpdb->base_prefix}wra_products_map` set `apiProductId`='{$data['productId']}', `ProductCnuId`='{$data['productUnitID']}', `productCode`='{$data['sku']}' where `productCode`='{$data['sku']}'";
				$wpdb->query($query);
			}
		}

		// $product->set_name($data['name']);
		// $product->set_status($data['status']);

		$product->set_sku($data['sku'].time());

	
		if (get_option('wra_update_price')=='on')
		{
			$product->set_regular_price($data['regular_price'] * $unit);
			if (get_option('wra_update_discount')=='on') {
				$product->set_price($data['price'] * $unit);				
				$product->set_sale_price($data['sale_price'] * $unit);
			
			}			
		}
		
	
		

		$product->set_catalog_visibility('visible');

		$product->set_stock_status($data['stock_status']);
		$product->set_manage_stock($data['manage_stock']);
		$product->set_stock_quantity($data['stock_quantity']);

		// $product->set_sold_individually( true );

		if (get_option('wra_update_images')=='on')
		{
			wp_delete_attachment($product->id, true);
			if($data['image_id'])
				$product->set_image_id($data['image_id']);
		}

	
		if ($data['productGroups'])
			foreach ($data['productGroups'] as $group) {
			
				$query = "SELECT * FROM {$wpdb->base_prefix}wra_groups where group_id=" . intval($group->groupID).' limit 1';
				$result = $wpdb->get_results($query);
				if ($result) {
					//$groupId = get_cat_name(intval($result[0]->siteGroupId));
					$groupId='';
					$term = get_term_by( 'id', intval($result[0]->siteGroupId), 'product_cat', 'ARRAY_A' );
					if(isset($term['name']))
						$groupId = $term['name'];

					wp_set_object_terms($product->id, $groupId, 'product_cat');
				}
			}

		$product->save();

	}


}